      SUBROUTINE SF33D(X,N,NMAX,FUN1,FUN2,WORK,IERR)
      DIMENSION FUN1(NMAX),FUN2(NMAX),WORK(NMAX)
      INTEGER N,NMAX,N1,N2,NA,NB,NC1,NC2,I,J,K
      DOUBLE PRECISION X,FUN1,FUN2,WORK,PI,P,P0,P1,Q0,Q1,Q2,
     1R,R1,R2,R3,R4,R5,U,U1,U2,U3,U4,U5,V,V1,V2,V3,V4,V5,V6,
     1V7,SYS001,SYS039
      DATA  SYS001/3.141592653589793D0/,SYS039/
     10.5772156649015329D0/
      IF(N.LT.2) GO TO 27
      NC1=MAX0(N,2*INT(SNGL(X))+4)
      IF(NMAX.LT.NC1) GO TO 29
      IERR=0
      PI=SYS001
      IF(X) 1,1,2
    1 IERR=67
      GO TO 28
    2 NC1=INT(SNGL(DMAX1(X+1.D0,3.D0)))
      NC2=2*NC1+1
      IF(N-NC1) 3,3,4
    3 N2=N
      N1=N
      GO TO 7
    4 N1=NC1
      IF(N-NC2) 5,5,6
    5 N2=NC2+1
      GO TO 7
    6 N2=N
    7 IF(X.GE.10.D0) GO TO 14
      IF(X.GT.1.D0) GO TO 12
      R1=0.5*X
      R2=-R1**2
      U1=1.D0
      U2=1.D0
      U3=1.D0
      U4=1.D0
      P0=1.D0
      P1=1.D0
      Q0=-(DLOG(R1)+SYS039)
      V1=Q0
      Q1=V1+0.5D0
      V2=Q1
      DO 8 I=1,10
      U1=U1*R2/DFLOAT((N-1+I)*I)
      P0=P0+U1
      U2=U2*R2/DFLOAT((N-2+I)*I)
      P1=P1+U2
      R3=1.D0/DFLOAT(I)
      R4=1.D0/DFLOAT(I+1)
      U3=U3*R2*R3**2
      V1=V1+R3
      Q0=Q0+U3*V1
      U4=U4*R2*R3*R4
      V2=V2+0.5*(R3+R4)
      Q1=Q1+U4*V2
    8 CONTINUE
      FUN1(N)=P0
      FUN1(N-1)=P1
      R3=-0.6366197723675813D0
      FUN2(1)=R3*Q0
      FUN2(2)=R3*(1.D0-2.D0*R2*Q1)
      IF(N.EQ.2) GO TO 11
      FUN2(3)=FUN2(2)+R2*FUN2(1)*2.D0
      DO 9 I=4,N
      FUN2(I)=FUN2(I-1)+FUN2(I-2)*R2/DFLOAT((I-2)*(I-3))
    9 CONTINUE
      NA=N-2
      DO 10 J=1,NA
      I=NA-J+1
      FUN1(I)=FUN1(I+1)+FUN1(I+2)*R2/DFLOAT(I*(I+1))
   10 CONTINUE
   11 GO TO 31
   12 R1=0.5D0*X
      R2=-R1**2
      U1=1.D0
      U2=1.D0
      P0=1.D0
      P1=1.D0
      Q0=-(DLOG(R1)+SYS039)
      V1=Q0
      Q1=V1+0.5D0
      V2=Q1
      DO 13 I=1,27
      R3=1.D0/DFLOAT(I)
      R4=1.D0/DFLOAT(I+1)
      U1=U1*R2*R3**2
      P0=P0+U1
      V1=V1+R3
      Q0=Q0+U1*V1
      U2=U2*R2*R3*R4
      P1=P1+U2
      V2=V2+0.5D0*(R3+R4)
      Q1=Q1+U2*V2
   13 CONTINUE
      FUN1(1)=P0
      FUN1(2)=R1*P1
      R2=-2.D0/PI
      FUN2(1)=R2*Q0
      FUN2(2)=(0.5D0/R1+R1*Q1)*R2
      GO TO 16
   14 R1=0.125D0/X
      R2=-R1**2
      P0=1.D0
      Q0=1.D0
      P1=1.D0
      Q1=1.D0
      U1=1.D0
      U2=1.D0
      U3=1.D0
      U4=1.D0
      DO 15 I=1,12
      V1=2.D0*FLOAT(I)
      V2=2.D0*V1
      V3=((V2-3.D0)*(V2-1.D0))**2
      V4=V2**2-1.D0
      V5=V4*(V2-3.D0)
      V6=V5*(V2+3.D0)
      V5=V5*(V2-5.D0)
      V4=V4**2
      V7=R2/((V1-1.D0)*V1)
      U1=U1*V3*V7
      P0=P0+U1
      V2=R2/((V1+1.D0)*V1)
      U2=U2*V4*V2
      Q0=Q0+U2
      U3=U3*V5*V7
      P1=P1+U3
      U4=U4*V6*V2
      Q1=Q1+U4
   15 CONTINUE
      Q0=R1*Q0
      Q1=3.D0*R1*Q1
      U1=PI/2.D0
      U2=DSQRT(U1*X)
      U3=X+0.5D0*U1
      U4=DSIN(U3)/U2
      U5=DCOS(U3)/U2
      FUN1(1)=P0*U4-Q0*U5
      FUN1(2)=Q1*U4-P1*U5
      FUN2(1)=-(P0*U5+Q0*U4)
      FUN2(2)=-(P1*U4+Q1*U5)
   16 R1=2.D0/X
      DO 17 I=3,N1
      R2=R1*DFLOAT(I-2)
      FUN1(I)=R2*FUN1(I-1)-FUN1(I-2)
      FUN2(I)=R2*FUN2(I-1)-FUN2(I-2)
   17 CONTINUE
      IF(N1.EQ.N) GO TO 31
      R1=0.5D0*X
      R2=R1**2
      Q2=1.D0
      U=1.D0
      V=1.D0
      R3=R1
      NA=N2-2
      DO 18 I=1,NA
      V=V+1.D0/DFLOAT(I+1)
      U=U*R2/DFLOAT(I*(NA+1-I))
      Q2=Q2+U
      R3=R3*R1/FLOAT(I)
   18 CONTINUE
      U=1.D0
      P=1.D0
      R2=-R2
      IF(X-10.D0) 19,20,20
   19 K=29
      GO TO 23
   20 IF(X-25.D0) 21,22,22
   21 K=4*INT(SNGL(X))+1
      GO TO 23
   22 K=NC2-1
   23 Q1=0.5D0*V-DLOG(R1)-SYS039
      V=Q1
      DO 24 I=1,K
      R4=1.D0/DFLOAT(I)
      R5=1.D0/DFLOAT(N2-1+I)
      U=U*R2*R4*R5
      P=P+U
      V=V+0.5D0*(R4+R5)
      Q1=Q1+U*V
   24 CONTINUE
      Q2=0.5D0*Q2/R3
      R3=R3/DFLOAT(N2-1)
      P=P*R3
      Q1=Q1*R3
      R2=-2.D0/PI
      FUN1(N2)=P
      FUN2(N2)=R2*(Q1+Q2)
      R=2.D0/X
      WORK(N1)=0.D0
      NA=N1+1
      NB=N2-1
      DO 25 I=NA,NB
      WORK(I)=1.D0/(R*DFLOAT(I-1)  -WORK(I-1))
      FUN1(I)=WORK(I)*FUN1(I-1)
      FUN2(I)=WORK(I)*FUN2(I-1)
   25 CONTINUE
      DO 26 J=NA,NB
      I=NA+NB-J
      FUN1(I)=WORK(I)*FUN1(I+1)+FUN1(I)
      FUN2(I)=WORK(I)*FUN2(I+1)+FUN2(I)
   26 CONTINUE
      GO TO 31
   27 IERR=65
   28 CALL UTSF11(IERR,33)
      GO TO 31
   29 IERR=66
      GO TO 28
   31 RETURN
      END
